#!/usr/bin/php

<?php

/**
 * This script can execute either an external arbitrary PHP file, or PHP script typed in the paramers.
 *
 * The script will convert variables passed with "Prompt for user input" to PHP variables that can be used in the script
 *
 * v_{variable name} / p_{variable name}
 *
 * Any of the parameters are optional. If both are filled, the parameter for execute will dertmine which will run first
 *
 * Version: 1.0
 * Author: Alon Sabi (alon@sabi.me)
 * Date: 2014-04-24
 *
 */
 
 $variableOrder = ini_get('variables_order');

if(strpos($variableOrder,'E') === FALSE) {
   echo "Sorry, thid script requires the 'variables_order' to include the 'E' option\n";
   echo "You can adjust it by editing your /etc/php.ini file. 'EGPCS' should be the default value, which should work fine.\n";
   echo "Your variables_order is currently set to '$variableOrder' \n\n";
   echo "The script will now quit\n";
   exit;
}


//======================================================================
// Converts the Keyboard Maestro evironment variables to PHP variables
//
//  $_ENV["KMPARAM_*"] becomes p_{variable name}
//  $_ENV["KMVAR_*"] becomes v_{variable name}
//
//======================================================================


foreach($_ENV as $key => $value) {

 if (strpos($key,'KMPARAM_') !== false) {
    $varName = 'p_'.str_replace('KMPARAM_','',$key);
    $$varName = $value;
 }
 
 if (strpos($key,'KMVAR_') !== false) {
    $varName = 'v_'.str_replace('KMVAR_','',$key);
    $$varName = $value;
 }
}


//======================================================================
// Executes the scripts in the order requested
// 
// Note: The reason there are no functions, is to allow variable scope to work.
//
//======================================================================

if(trim($p_Optional_Full_PHP_Script_Path != '') && !file_exists($p_Optional_Full_PHP_Script_Path)) {
    echo "Could not find $p_Optional_Full_PHP_Script_Path\n";
}

if ($p_Execute == 'Script First') {


    // Execute the script followed by the file provided

    if (trim($p_Optional_PHP_Content) != '') {
         if (!file_exists($p_Temporary_Folder) || !is_writable($p_Temporary_Folder)) {
		   echo "\n=============================================================\n";
		   echo "Note: the script needs to be able to write to the temporary folder provided ($p_Temporary_Folder).\n";
		   echo "It is currently not writable, or does not exist\n";
		   echo "=============================================================\n";
		}
    
        // for some reason, double quotes get the "special ones"
        $content = str_replace(array("”","“"),"\"",$p_Optional_PHP_Content);
		$fileName = tempnam('/var/tmp','php_script_');
		file_put_contents($fileName, $content);
		require_once($fileName);
		unlink($fileName);
    }
    
    if(trim($p_Optional_Full_PHP_Script_Path != '') && file_exists($p_Optional_Full_PHP_Script_Path)) {
	    require_once($p_Optional_Full_PHP_Script_Path);
    }
   
} else {
     
    // Execute the file followed by the script provided
     
	 if(trim($p_Optional_Full_PHP_Script_Path != '') && file_exists($p_Optional_Full_PHP_Script_Path)) {
	    require_once($p_Optional_Full_PHP_Script_Path);
     }
    
     if (trim($p_Optional_PHP_Content) != '') {
     
        if (!file_exists($p_Temporary_Folder) || !is_writable($p_Temporary_Folder)) {
        
		   echo "\n=============================================================\n";
		   echo "Note: the script needs to be able to write to the temporary folder provided ($p_Temporary_Folder).\n";
		   echo "It is currently not writable, or does not exist\n";
		   echo "=============================================================\n";
		}
     
        // for some reason, double quotes get the "special ones"
        $content = str_replace(array("”","“"),"\"",$p_Optional_PHP_Content);
		$fileName = tempnam('/var/tmp','php_script_');
		file_put_contents($fileName, $content);
		require_once($fileName);
		unlink($fileName);

    }
}


  

